#!/usr/bin/awk -f

BEGIN{
  pi=3.1415926535;

  YARKO="yarko.in";
  SPIN="spin.in";
  TPIN="tp.in";
  i=0;
}
(ARGIND==1) && !/^#/{
  i++;
  r[i] = $1 * 1000.;	# m, radius (NOT diameter)
}
(ARGIND==2) && (FNR % 4==2){
  j++;
  x[j]=$1;
  y[j]=$2;
  z[j]=$3;
}
(ARGIND==2) && (FNR % 4==3){
  vx[j]=$1;
  vy[j]=$2;
  vz[j]=$3;
}
END{
  NTP=i;
  nclones = 1;
  print NTP*nclones;
  print NTP*nclones >YARKO;
  print NTP*nclones"\n-1\n1" >SPIN;
  print NTP*nclones >TPIN;

  srand(-1);

  j1 = 1;
  j2 = 1;
  for (i=1; i<=NTP; i++) {

    for (j=1; j<=nclones; j++) {
      s1 = 2.*pi*rand();
#      sins2 = -1. + 2.*(j-1)/(nclones-1);  # NOT random
      sins2 = -1. + 2.*rand();
      coss2 = sqrt(1.-sins2**2);
      sx = cos(s1)*coss2;
      sy = sin(s1)*coss2;
      sz = sins2;

#      if (i==1) {
#        p = 10.227;  # 1st largest remnant
#      } else if (i==2) {
#        p = 20.51;  # 2nd largest fragment
#      } else {
#        p = 2.+10.*rand();	# h, rotation period
#      }
      p = 2.+10.*rand();	# h, rotation period
      omega = 2.*pi/(p*3600.)

      printf("%9.3f 3500.0 3500.0 0.0010  680.0 0.10 0.90\n", r[i]) >YARKO;
      printf("%12.8f %12.8f %12.8f %15.8e\n", sx,sy,sz, omega) >SPIN;
      printf("%22.16e %22.16e %22.16e\n", x[i],y[i],z[i]) >TPIN;
      printf("%22.16e %22.16e %22.16e\n", vx[i],vy[i],vz[i]) >TPIN;
      printf("0\n") >TPIN;
      printf("0.0\n") >TPIN;
    }
  }
}

